"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var regex = /^%([\w\d.]+)%$/i;
function patcher(translations) {
    return function (value) {
        if (typeof value !== 'string') {
            return;
        }
        var match = regex.exec(value);
        if (!match) {
            return;
        }
        return translations[match[1]] || value;
    };
}
function patchNLS(manifest, translations) {
    return lodash_1.cloneDeepWith(manifest, patcher(translations));
}
exports.patchNLS = patchNLS;

//# sourceMappingURL=nls.js.map
