import restm = require('./RestClient');
import httpm = require('./HttpClient');
import vsom = require('./VsoClient');
import VsoBaseInterfaces = require('./interfaces/common/VsoBaseInterfaces');
import * as rm from 'typed-rest-client/RestClient';
import * as hm from 'typed-rest-client/HttpClient';
export declare class ClientApiBase {
    baseUrl: string;
    userAgent: string;
    http: hm.HttpClient;
    rest: rm.RestClient;
    httpClient: httpm.HttpCallbackClient;
    restCallbackClient: restm.RestCallbackClient;
    restClient: restm.RestClient;
    vsoClient: vsom.VsoClient;
    constructor(baseUrl: string, handlers: VsoBaseInterfaces.IRequestHandler[], userAgent?: string);
    setUserAgent(userAgent: string): void;
    connect(): Promise<any>;
    createAcceptHeader(type: string, apiVersion?: string): string;
    createRequestOptions(type: string, apiVersion?: string): rm.IRequestOptions;
    formatResponse(data: any, responseTypeMetadata: any, isCollection: boolean): any;
}
