import basem = require('./ClientApiBases');
import VsoBaseInterfaces = require('./interfaces/common/VsoBaseInterfaces');
import ContributionsInterfaces = require("./interfaces/ContributionsInterfaces");
export interface IContributionsApi extends basem.ClientApiBase {
    queryContributionNodes(query: ContributionsInterfaces.ContributionNodeQuery): Promise<ContributionsInterfaces.ContributionNodeQueryResult>;
    queryDataProviders(query: ContributionsInterfaces.DataProviderQuery): Promise<ContributionsInterfaces.DataProviderResult>;
    getInstalledExtensions(contributionIds?: string[], includeDisabledApps?: boolean, assetTypes?: string[]): Promise<ContributionsInterfaces.InstalledExtension[]>;
    getInstalledExtensionByName(publisherName: string, extensionName: string, assetTypes?: string[]): Promise<ContributionsInterfaces.InstalledExtension>;
}
export declare class ContributionsApi extends basem.ClientApiBase implements IContributionsApi {
    constructor(baseUrl: string, handlers: VsoBaseInterfaces.IRequestHandler[]);
    /**
     * Query for contribution nodes and provider details according the parameters in the passed in query object.
     *
     * @param {ContributionsInterfaces.ContributionNodeQuery} query
     */
    queryContributionNodes(query: ContributionsInterfaces.ContributionNodeQuery): Promise<ContributionsInterfaces.ContributionNodeQueryResult>;
    /**
     * @param {ContributionsInterfaces.DataProviderQuery} query
     */
    queryDataProviders(query: ContributionsInterfaces.DataProviderQuery): Promise<ContributionsInterfaces.DataProviderResult>;
    /**
     * @param {string[]} contributionIds
     * @param {boolean} includeDisabledApps
     * @param {string[]} assetTypes
     */
    getInstalledExtensions(contributionIds?: string[], includeDisabledApps?: boolean, assetTypes?: string[]): Promise<ContributionsInterfaces.InstalledExtension[]>;
    /**
     * @param {string} publisherName
     * @param {string} extensionName
     * @param {string[]} assetTypes
     */
    getInstalledExtensionByName(publisherName: string, extensionName: string, assetTypes?: string[]): Promise<ContributionsInterfaces.InstalledExtension>;
}
