export interface Collection {
    data: {
        [key: string]: any;
    };
    dateCreated: Date;
    /**
     * Identifier for a collection under an organization
     */
    id: string;
    lastUpdated: Date;
    /**
     * The unqiue name of collection under an organziation
     */
    name: string;
    owner: string;
    preferredRegion: string;
    /**
     * Extended properties
     */
    properties: any;
    status: CollectionStatus;
}
export declare enum CollectionStatus {
    Unknown = 0,
    Initial = 10,
    Enabled = 20,
    LogicallyDeleted = 30,
    MarkedForPhysicalDelete = 40,
}
export interface Organization {
    collections: Collection[];
    creatorId: string;
    data: {
        [key: string]: any;
    };
    dateCreated: Date;
    /**
     * Identifier for an Organization
     */
    id: string;
    isActivated: boolean;
    lastUpdated: Date;
    name: string;
    primaryCollection: Collection;
    /**
     * Extended properties
     */
    properties: any;
    status: OrganizationStatus;
    tenantId: string;
    type: OrganizationType;
}
export interface OrganizationMigrationBlob {
    blobAsJson: string;
    id: string;
}
export declare enum OrganizationSearchKind {
    Unknown = 0,
    ById = 1,
    ByName = 2,
    ByTenantId = 3,
}
export declare enum OrganizationStatus {
    Unknown = 0,
    Initial = 10,
    Enabled = 20,
    MarkedForDelete = 30,
}
export declare enum OrganizationType {
    Unknown = 0,
    Personal = 1,
    Work = 2,
}
export interface Policy {
    effectiveValue: any;
    enforce: boolean;
    isValueUndefined: boolean;
    name: string;
    parentPolicy: Policy;
    value: any;
}
export interface PolicyInfo {
    description: string;
    moreInfoLink: string;
    name: string;
}
export interface Region {
    /**
     * Display name for the region.
     */
    displayName: string;
    /**
     * Name identifier for the region.
     */
    name: string;
}
export declare var TypeInfo: {
    Collection: {
        fields: any;
    };
    CollectionStatus: {
        enumValues: {
            "unknown": number;
            "initial": number;
            "enabled": number;
            "logicallyDeleted": number;
            "markedForPhysicalDelete": number;
        };
    };
    Organization: {
        fields: any;
    };
    OrganizationMigrationBlob: {
        fields: any;
    };
    OrganizationSearchKind: {
        enumValues: {
            "unknown": number;
            "byId": number;
            "byName": number;
            "byTenantId": number;
        };
    };
    OrganizationStatus: {
        enumValues: {
            "unknown": number;
            "initial": number;
            "enabled": number;
            "markedForDelete": number;
        };
    };
    OrganizationType: {
        enumValues: {
            "unknown": number;
            "personal": number;
            "work": number;
        };
    };
    Policy: {
        fields: any;
    };
    PolicyInfo: {
        fields: any;
    };
    Region: {
        fields: any;
    };
};
